import os from 'os'
import { shellCommand } from 'cerebro-tools'

const DIR_REGEXP = /^\/(.*\/)*(.*)/
const HOME_DIR_REGEXP = /^~/
const USER_PATH = os.homedir()


export const fn = ({ term, actions, display }) => {

  let path = term
  let replaceHomePath = false
  if (path.match(HOME_DIR_REGEXP)) {
    path = path.replace(HOME_DIR_REGEXP, USER_PATH)
    replaceHomePath = true
  }

  const match = path.match(DIR_REGEXP)
  if (match) {
    const dir = match[1] ? `/${match[1]}` : '/'
    const fileName = match[2]


    const osa1 = `'tell application "iTerm"'`
    const osa2 = `'activate'`
    const osa3 = `'set win to (create window with default profile)'`
    const osa4 = `'set sesh to (current session of win)'`
    const osa5 = `'tell sesh to write text "cd ${dir}"'`
    const osa6 = `'end tell'`

    let cmd = `/usr/bin/osascript -e ${osa1} -e ${osa2} -e ${osa3} -e ${osa4} -e ${osa5} -e ${osa6}`

    display({
      title: `Open in iTerm ${fileName}`,
      subtitle: `Open ${dir} in terminal`,
      onSelect: () => shellCommand(cmd)
    })

  }
}
